/* FatBin Extractor - LGPL - Copyright 2010 nibble <develsec.org>
 * LaCon'10 */

using Radare;

static RBin b;

static void doextract(string outdir) {
	int i;
	/* Iterate over "sub-bins" */
	for (i = 0; i < b.narch; i++) {
		b.set_archidx (i);
		var info = b.get_info ();
		if (info == null) {
			print ("Warning: No extract info found for arch %i\n", i);
			continue;
		}
		/* Dump to outdir/file.arch_bits */
		string? filename = b.curarch.file.rstr("/");
		if (filename != null)
			filename = filename.replace ("/", "");
		string output = "%s/%s.%s_%i".printf (
				outdir, filename!=null?filename:b.curarch.file, info.arch, info.bits);
		if (RFile.dump (output, b.curarch.buf.buf, b.curarch.size) == 0)
			print ("Error: Cannot dump %s\n", output);
		else print ("%s created (%i)\n", output, b.curarch.size);
	}
}

public static void main(string[] args) {
	/* Parse args */
	if (args.length != 3)
		error ("Usage: %s <file> <output dir>\n", args[0]);
	var file = args[1];
	var outdir = args[2];
	/* Init r_bin */
	b = new RBin ();
	if (b.load (file, false) == 0)
		error ("Error: r_bin cannot load the file");
	/* Do extract */
	doextract (outdir);
}
